cls
data 0,8, 1, 9,25 ,5,12, 4,36,52,38,26,22,62,55,63
'defdbl a - z
dim huge dat(20000)
dim cols%(15)
pi = 3.14159265358979323
comport$ = environ$("DSPCOM")
if comport$ = "" then
	sound 400 , 1
	print "Environment variable DSPCOM not set   eg. DSPCOM=2"
	end
end if
if instr(ucase$(command$) , "QUICK") > 0 then quickstart% = -1
screen 12
locate 30 , 30
print "Interface on COM";comport$;
def seg = &h40
comaddr% = peeki(2 * val(comport$) - 2)
out comaddr% + 4 , 3         'set DTR and RTS for interface
colfact = .05
threshold = 0
def seg = varseg (dat(1))
datadr% = varptr (dat(1))
color 7
nsamples% = 512
locate 5 , 15
color 14
print "Serial A/D converter colour waterfall display"
color 7
locate 6 , 30
print "Adjust input level..."
if not quickstart% then CheckLevel
locate 18 , 10
color 15 : print "Sampling rate  Hz  ";
color 12 : print tab(30);"1 "; : color 7 : print "  10000 Hz   100 us";
color 12 : print tab(30);"2 "; : color 7 : print "   7143 Hz   140 us";
color 12 : print tab(30);"3 "; : color 7 : print "   2500 Hz   400 us";
color 12 : print tab(30);"4 "; : color 7 : print "   1000 Hz  1000 us";
while not instat : wend
a$ = ucase$(inkey$)
select case a$
case "4"
	BaseSampleRate = 1000
case "2"
	BaseSampleRate = 1e6 / 140
case "3"
	BaseSampleRate = 2500
case "1" , chr$(13)
	BaseSampleRate = 10000
case else
	sound 400 , 1
	end
end select
locate 23 , 15
input "Decimation factor     (1)     ",decim%
if decim% = 0 then decim% = 1
locate 25 , 15
print  "Window type ";
color 12:print "N";:color 7:print "one ";
color 12:print "H";:color 7:print "amming ";
color 12:print "B";:color 7:print "lackman Harris
while not instat : wend
windowtype% = instr("NHB" , ucase$(inkey$))
locate 27 , 15
print "Colour map   linear [";
color 12:print "P";:color 7:print "]ower ";
color 12:print "L";:color 7:print "og ";
while not instat : wend
ik$ = ucase$(inkey$)
if ik$ = "L" then lg% = -1
locate 28 , 15
color 12 : print "G";
color 7  : print "rey scale or ";
color 12 : print "C";
color 7  : print "olour"
while not instat : wend
if ucase$(inkey$) = "G" then grey% = -1

reg 1 , 0 : call interrupt &h33
reg 1 , 4 : reg 3 , 630 : reg 4 , 0 : call interrupt &h33
reg 1 , 1 : call interrupt &h33
reg 1 , 7 : reg 3 , 0 : reg 4 , 256 : call interrupt &h33
if grey% then
	for i% = 0 to 15
		r% = i% * 4 + 3
		g% = i% * 4 + 3
		b% = i% * 4 + 3
		reg 1 , &h1010
		reg 2 , i%
		reg 3 , 256 * g% + b%
		reg 4 , r% * 256
		call interrupt &h10
		palette i% , i%
	next i%
else
	for t% = 0 to 15
		read pa%
		palette t% , pa%
	next t%
end if
cls

do
	showmap
	for l% = 0 to 447
		x% = min(638 , nsamples% / 2 + 2)
		line (x% , oldl%) - (oldx% + 6 , oldl%) , 0
		line (x% , l%) - (oldx% + 6 , l%) , 15
		oldl% = l% : oldx% = x%
		if not quickstart% then call ReadAdc (nsamples%)
		select case windowtype%
		case 2
			call BlackHarrisWind(dat() , nsamples%)
		case 3
			call HammingWind(dat() , nsamples%)
		end select
		call FFT (dat() , nsamples% , 1)
		for k% = 2 to nsamples% step 2
			magsq = ((dat(k% - 1) ^ 2 + dat(k%) ^ 2)) / nsamples% ^ 2
			if lg% then
				colref% = max(min(log10(magsq) * colfact * 100  , 15) , 0)
			else
				colref% = min(max((magsq + threshold) * colfact, 0) ,15)
			end if
			pset (k% / 2 - shft% , l%) , colref%
		next k%
		if instat then gosub DoAction
		samplerate = BaseSamplerate / decim%
		span = samplerate / 2
		binsize = samplerate / nsamples%
		reg 1 , 3
		call interrupt &h33
		freq = (reg(3) + shft%) * binsize
		but% = reg(2)
		if but% mod 2 = 1 then relto = freq
		viewspan = span
		if nsamples% > 1024 then
			viewspan = 640 * binsize
		end if
		locate 29 , 1 : print using "####.## Hz ";shft% * binsize;
		xpos% = min(70 , nsamples% / 16+ 1)
		locate 29 , xpos%:print using "####.# Hz";shft% * binsize + viewspan;
		locate 30 , 10
		print using "#### x###.# Hz Bins  Cursor ####.#  [+####.#]      ";_
				nsamples% / 2, binsize, freq, freq - relto;
		if nsamples% > 1024 then
			print "< > Scroll screen";
		else
			print "                 ";
		end if
		reg 1 , 7 : reg 3 , 0 : reg 4 , min(nsamples% / 2, 630) : call interrupt &h33
	next l%
loop
end
'==========================================================================
sub ReadAdc (n%)
	shared decim% , comport$, comaddr% , dat()
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1 , dt , ds, cs , cd , me , fe" as 1 len = 30000
	for samplecount% = 1 to 2 * n% - 1 step 2
		for decimcount% = 1 to decim%
			do until loc(1) > 0  :  loop
			a$ = input$(loc(1) , 1)
			value% = asc(a$) - 128
			if decimcount% = 1 then
				dat(samplecount%) = value%
				dat(samplecount% + 1) = 0
			else
				dat(samplecount%) = value% / decim% + dat(samplecount%)
				dat(samplecount% + 1) = 0
			end if
		next decimcount%
	next samplecount%
	close 1
	out comaddr% + 4 , 3
end sub

sub FFT(dat(1) , nn% , isign%)          'isign% = 1 for FFT,  -1 for INV FFT
'data format  (re,im,re,im,....) starting at 1
	shared pi
	n% = 2 * nn%
	j% = 1
	for i% = 1 to n% step 2
		if j% > i% then
			swap dat(i%) , dat(j%)
			swap dat(i% + 1) , dat(j% + 1)
		end if
		m% = n% \ 2
		while m% >= 2 and j% > m%
			decr j% , m%
			m% = m% \ 2
		wend
		incr j% , m%
	next i%
	mmax% = 2

	while n% > mmax%
		istep% = 2 * mmax%
		theta = 2 * pi / (isign% * mmax%)
		wpr = cos(theta)
		wpi = sin(theta)
		wr = 1
		wi = 0
		for m% = 1 to mmax% step 2
			for i% = m% to n% step istep%
				j% = i% + mmax%
				tempr% = wr * dat(j%) - wi * dat(j% + 1)
				tempi% = wr * dat(j% + 1) + wi * dat(j%)
				dat(j%) = dat(i%) - tempr%
				dat(j% + 1) = dat(i% + 1) - tempi%
				incr dat(i%) , tempr%
				incr dat(i% + 1) , tempi%
			next i%
			wtemp = wr
			wr = wr * wpr - wi * wpi
			wi = wi * wpr + wtemp * wpi
		next m%
		mmax% = istep%
	wend
end sub

sub BlackHarrisWind (dat() , n%)
	shared pi
	for k% = 0 to n% - 1
   	locdat% = k% * 2 + 1
		theta = 2 * pi * k% / n%
		dat(locdat%) = dat(locdat%) * (.42323 - .49755 * cos(theta) + .07922 * cos(2 * theta)) / .42
		dat(locdat% + 1) = dat(locdat% + 1) * (.42323 - .49755 * cos(theta) + .07922 * cos(2 * theta)) / .42
	next k%
end sub

sub HammingWind (dat() , n%)
	shared pi
	for k% = 0 to n% - 1
		locdat% = k% * 2 + 1
		theta = 2 * pi * k%/ n%
		dat(locdat%) = dat(locdat%) * (1 - .851852 * cos(theta))    'includes weighting
		dat(locdat% + 1) = dat(locdat% + 1) * (1 - .851852 * cos(theta))    'includes weighting

	next k%
end sub

sub ShowMap
	shared cols%()
	for t% = 0 to 15
		color t%
		locate t% + 5 , 80
		print "";
	next t%
end sub

sub CheckLevel
	shared comport$, comaddr%, dat()
	close 1   'since probably already open
	for t% = 0 to 4095
		dat(t%) = 0
	next t%
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1, ds, cs , cd , me , fe" as 1 len = 30000
	line (191 , 230) - (191 , 254) , 10
	line (449 , 230) - (449 , 254) , 10
	do
		do until loc(1) > 0
			if instat then ik$ = inkey$
		loop
      if ik$ = chr$(27) then end
		a$ = input$(loc(1) , 1)
		value% =  abs(asc(a$) - 128)
		if value% > 126 then co% = 12 else co% = 11
		line (192 , 240) - (448 , 243) , 0 , bf
		line (320 - value% , 240) - (320 + value% , 243) , co% , bf
		if instat then ik$ = inkey$
	loop until ik$ > ""
	close 1
   out comaddr% + 4 , 3
end sub

DoAction:
	a$ = ucase$(inkey$)
	select case a$
	case "+"
		nsamples% = min (nsamples% * 2 , 8192)
		cls : l% = 0
      reg 1 , 4 : reg 3 , 630 : reg 4 , 0 : call interrupt &h33
	case "-"
		nsamples% = max (nsamples% \ 2 , 32)
		shft% = 0
		cls : l% = 0
      reg 1 , 4 : reg 3 , nsamples% / 2 : reg 4 , 0 : call interrupt &h33
	case "C"
		colfact = colfact * 1.1
	case chr$(3)
		colfact = colfact / 1.1
	case "R"
		cls
		l% = 0
		showmap
		reg 1 , 4 : reg 3 , 630 : reg 4 , 0 : call interrupt &h33
	case "D"
		incr decim% , 1
	case chr$(4)
		decim% = max(decim% - 1 , 1)
	case chr$(27)
		end
	case "<" , "," , chr$(0 ,75)
		if nsamples% <= 1024 then shft% = 0 :return
		shft% = max(shft% - 160 , 0)
	case ">" ,"." , chr$(0 , 77)
		if nsamples% <= 1024 then shft% = 0 : return
		shft% = min(shft% + 160 , nsamples% / 2 - 640)
	case "T"
		threshold = threshold + 5
	case chr$(20)
		threshold = threshold - 5
	case chr$(0 , 59)
		call MakeBMP("WFL16")
	end select
	binsize = samplerate / nsamples% / decim%
	a$ = ""
	locate 29 , 1 : print space$(80);
return

sub MakeBmp(basename$)       'Palette table assumes EGA compatibility
	filename$ = dir$(basename$ + "???.bmp")
	n% = val(mid$(filename$ , 6, 3))
	do
		f$ = dir$
		n% = max(val(mid$(f$ , 6, 3)) , n%)
	loop until f$ = ""
	n$ = mid$(str$(min(n% + 1, 999)) , 2)
	do while len(n$) < 3
		n$ = "0" + n$
	loop
	f$ = basename$ + n$ + ".BMP"
	locate 30 , 60
	print using "\            \    ";f$;
	bwidth& = 640           'previously set by   PALETTE CO%,CO%
	bheight& = 480
	ColoursInTable& = 16
	BitsPerPixel% = 4        '1 / 4 / 8 / 24  only
	NPlanes% = 1             '1 only
	InfoSize& = 40

	ImageSize& = bwidth& * bheight& * BitsperPixel% / 8
	dataoffset& = 54 + ColoursInTable& * 4
	filesize& = dataoffset& + ImageSize&

	t = timer
	if instr(ucase$(f$) , ".BMP") = 0 then f$ = f$ + ".BMP"
	fi% = freefile
	open "b" , fi% , f$
	i1% = 0 : i2% = 0 : compression& = 0
	bm$ = "BM"
	put$ fi% , bm$
	put fi% , 2 , filesize&
	put fi% ,, i1%
	put fi% ,, i2%
	put fi% ,, DataOffset&
	put fi% ,, InfoSize&
	put fi% ,, bwidth&
	put fi% ,, bheight&
	put fi% ,, NPlanes%
	put fi% ,, BitsPerPixel%
	put fi% ,, compression&
	put fi% ,, ImageSize&
	put fi% ,, XPelsPerMetre&
	put fi% ,, YPelsPerMetre&
	put fi% ,, ColoursInTable&
	put fi% ,, ImportantColours&

	seek fi% , 54
	for rgb% = 0 to 15
		reg 1 , &h1015
		reg 2 , rgb%
		call interrupt &h10
		b% = (reg(3) mod 256) * 4
		g% = (reg(3) \ 256) * 4
		r% = (reg(4) \ 256) * 4
		pa$ = chr$(b%) + chr$(g%) + chr$(r%) + chr$(0)
		put$ fi% , pa$
	next rgb%

	seek fi% , dataoffset&         'data starts at bottom left of picture
	nibble% = 0
	for y% = bheight& - 1 to 0 step -1
		dat$ = ""
		for x% = 0 to bwidth& - 2 step 2
				d% = 16 * point (x% , y%) + point (x% + 1 , y%)
				dat$ = dat$ + chr$(d%)
		next x%
      put$ fi% , dat$
	next y%
	close fi%
	sound 1750 , 2
   locate 30 , 60
	print  space$(17);
end sub