cls
data 0,8, 1, 9,25 ,5,12, 4,36,52,38,26,22,62,55,63
'defdbl a - z
dim huge dat(16384) , bitpatt$(3)
dim cols%(15) , dispdat(8192)
pi = 3.14159265358979323
comport$ = environ$("DSPCOM")
if instr(ucase$(command$) , "QUICK") > 0 then quickstart% = -1
if comport$ = "" then
	sound 400 , 1
	print "Environment variable DSPCOM not set   eg. DSPCOM=2"
	end
end if
readfonts
locate 25 , 30
print "Interface on COM";comport$;
def seg = &h40
comaddr% = peeki(2 * val(comport$) - 2)
out comaddr% + 4 , 3         'set DTR and RTS for interface
def seg = varseg (dat(1))
datadr% = varptr (dat(1))
color 7
nsamples% = 512
bf = 1 : rf = 1 : gf = 1 : threshold% = 0 : colfact = 2
locate 5 , 15
color 14
print "Serial A/D converter colour waterfall display"
color 7
locate 6 , 30
print "Adjust input level..."
if not quickstart% then CheckLevel
locate 11, 10
color 15 : print "Sampling rate  Hz  ";
color 12 : print tab(30);"1 "; : color 7 : print "  10000 Hz   100 us";
color 12 : print tab(30);"2 "; : color 7 : print "   7143 Hz   140 us";
color 12 : print tab(30);"3 "; : color 7 : print "   2500 Hz   400 us";
color 12 : print tab(30);"4 "; : color 7 : print "   1000 Hz  1000 us";
while not instat : wend
a$ = ucase$(inkey$)
select case a$
case "4"
	BaseSampleRate = 1000
case "2"
	BaseSampleRate = 1e6 / 140
case "3"
	BaseSampleRate = 2500
case "1" , chr$(13)
	BaseSampleRate = 10000
case else
	sound 400 , 1
	end
end select
locate 16 , 15
input "Decimation factor     (1)     ",decim%
if decim% = 0 then decim% = 1
samplerate = basesamplerate / decim%
span = samplerate / 2
viewspan = span
binsize = samplerate / nsamples%
locate 17 , 15
print  "Window type [";
color 12:print "N";:color 7:print "]one ";
color 12:print "H";:color 7:print "amming ";
color 12:print "B";:color 7:print "lackman Harris
while not instat : wend
windowtype% = instr("NHB" , ucase$(inkey$))
locate 18 , 15
print "Colour map   [";
color 12:print "V";:color 7:print "]oltage  or ";
color 12:print "P";:color 7:print "ower ";
color 12:print "L";:color 7:print "og ";
while not instat : wend
ik$ = ucase$(inkey$)
if ik$ = "P" then PowerFlag% = -1
if ik$ = "L" then LogFlag% = -1
locate 19 , 15
input "Samples to average [2] ",avno%
if avno% = 0 then avno% = 2
locate 21 , 15
input "Marker frequency    [rtn] = none  ",fmark
if fmark > 0 then markx% = (fmark / binsize) - shft%
locate 23 , 15
print "Scroll display  Y / n "
while not instat : wend
if ucase$(inkey$) = "N" then ScrollFlag% = 0 else ScrollFlag% = -1
def seg = &hA000
reg 1 , &h13
call interrupt &h10
call SetUpPalette
clrscn
ShowText
if markx% > 0 and markx% < 256 then
	for y% = 197 to 199
		mp& = markx% + 320 * y%
		poke mp& , 255
	next y%
end if
do
	for av% = 1 to avno%
		call ReadAdc (nsamples%)
		select case windowtype%
		case 2
			call BlackHarrisWind(dat() , nsamples%)
		case 3
			call HammingWind(dat() , nsamples%)
		end select
		call FFT (dat() , nsamples% , 1)
		for k% = 1 to nsamples% step 2
			dispdat(k% \ 2)  = dat(k% - 1) ^ 2  + dat(k%)^ 2 + dispdat(k% \ 2)
		next k%
	next av%

	if counter& < 197 then
		y% = counter&
	else
		if ScrollFlag% then
			y% = 196
			scroll
		else
			counter& = 0
		end if
	end if
	x% = min(257 , nsamples% / 2 + 1)
	poke lasty% * 320 + lastx% , 0
	poke y% * 320 + lastx% , 255
	lasty% = y% : lastx% = x%
	for k% = 0 to nsamples% / 2 - 1
		magsq = dispdat(k%) / avno% ^ 2 / nsamples% ^ 2
		dispdat(k%) = 0
		if PowerFlag% then
			co% = min((magsq) , 255)
		else
			if logflag% then
				co% = max(min(50 * log10(magsq) , 255) , 0)    '0.2dB per colour
			else
				co% = min(sqr(magsq) * 8 , 255)
			end if
		end if
		x% = k% - shft%
		if x% > 0 and x% < 257 then
			vad& = x% + 320 * y%
			poke vad& , co%
		end if
	next k%
	if instat then gosub DoAction
	binsize = samplerate / nsamples%
	incr counter&
loop
end
'==========================================================================
sub ReadAdc (n%)
	shared decim% , comport$, comaddr% , dat()
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1 , dt , ds, cs , cd , me , fe" as 1 len = 30000
	for samplecount% = 1 to 2 * n% - 1 step 2
		for decimcount% = 1 to decim%
			do until loc(1) > 0  :  loop
			a$ = input$(loc(1) , 1)
			value% = asc(a$) - 128
			if decimcount% = 1 then
				dat(samplecount%) = value%
				dat(samplecount% + 1) = 0
			else
				dat(samplecount%) = value% / decim% + dat(samplecount%)
				dat(samplecount% + 1) = 0
			end if
		next decimcount%
	next samplecount%
	close 1
	out comaddr% + 4 , 3
end sub

sub FFT(dat(1) , nn% , isign%)          'isign% = 1 for FFT,  -1 for INV FFT
'data format  (re,im,re,im,....) starting at 1
	shared pi
	n% = 2 * nn%
	j% = 1
	for i% = 1 to n% step 2
		if j% > i% then
			swap dat(i%) , dat(j%)
			swap dat(i% + 1) , dat(j% + 1)
		end if
		m% = n% \ 2
		while m% >= 2 and j% > m%
			decr j% , m%
			m% = m% \ 2
		wend
		incr j% , m%
	next i%
	mmax% = 2

	while n% > mmax%
		istep% = 2 * mmax%
		theta = 2 * pi / (isign% * mmax%)
		wpr = cos(theta)
		wpi = sin(theta)
		wr = 1
		wi = 0
		for m% = 1 to mmax% step 2
			for i% = m% to n% step istep%
				j% = i% + mmax%
				tempr% = wr * dat(j%) - wi * dat(j% + 1)
				tempi% = wr * dat(j% + 1) + wi * dat(j%)
				dat(j%) = dat(i%) - tempr%
				dat(j% + 1) = dat(i% + 1) - tempi%
				incr dat(i%) , tempr%
				incr dat(i% + 1) , tempi%
			next i%
			wtemp = wr
			wr = wr * wpr - wi * wpi
			wi = wi * wpr + wtemp * wpi
		next m%
		mmax% = istep%
	wend
end sub

sub BlackHarrisWind (dat() , n%)
	shared pi
	for k% = 0 to n% - 1
   	locdat% = k% * 2 + 1
		theta = 2 * pi * k% / n%
		dat(locdat%) = dat(locdat%) * (.42323 - .49755 * cos(theta) + .07922 * cos(2 * theta)) / .42
		dat(locdat% + 1) = dat(locdat% + 1) * (.42323 - .49755 * cos(theta) + .07922 * cos(2 * theta)) / .42
	next k%
end sub

sub HammingWind (dat() , n%)
	shared pi
	for k% = 0 to n% - 1
		locdat% = k% * 2 + 1
		theta = 2 * pi * k%/ n%
		dat(locdat%) = dat(locdat%) * (1 - .851852 * cos(theta))    'includes weighting
		dat(locdat% + 1) = dat(locdat% + 1) * (1 - .851852 * cos(theta))
	next k%
end sub

sub CheckLevel
	shared comport$, comaddr%, dat()
	close 1   'since probably already open
	for t% = 0 to 4095
		dat(t%) = 0
	next t%
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1, ds, cs , cd , me , fe" as 1 len = 30000
	do
		do until loc(1) > 0
			if instat then ik$ = inkey$
		loop
      if ik$ = chr$(27) then end
		a$ = input$(loc(1) , 1)
		value% =  abs(asc(a$) - 128)
		if value% > 126 then color 12 else color 7
		locate 9 , 1 : print space$(80);
		locate 9 , 40 - value% / 3.3 : print string$(value% / 1.6 , 205);
		if instat then ik$ = inkey$
	loop until ik$ > ""
	if inkey$ = chr$(27) then end
	close 1
   out comaddr% + 4 , 3
end sub

sub scroll
	shared nsamples%
	ns% = min(nsamples% / 2 + 1  , 256)
	for li% = 1 to 196
		ad& = li% * 320
		a$ = peek$(ad& , ns%)
		poke$ ad& - 320 , a$
	next li%
end sub

sub SetUpPalette
	shared threshold% , colfact , palno%
	out &h3c6 , &hff
	for i% = 0 to 255
		j% = max(i% - threshold% , 0)
		select case palno%
		case 1
			r% = max(min(j% * colfact / 4, 63) , 0 )
			g% = max(min(j% * colfact / 4, 63) , 0 )
			b% = max(min(j% * colfact / 4, 63) , 0 )
		case 0
			if j% * colfact > 42 then g% = min (1.5 * (colfact * j% - 42) , 63) else g% = 0
			if j% * colfact> 127 then r% = min(1.5 * (colfact * j% - 127) , 63)
			b% = min(1.5 * colfact * j%  , 63)
			if j% * colfact > 85 then b% = max(1.5 * (122 - colfact * j%) , 0)
			if j% * colfact > 212 then b% = max(min(1.5 * (colfact * j% - 212) , 63) , 0)
		case 3
			r% = max(min(j% * colfact / 2, 63) , 0 )
			g% = max(min(j% * colfact / 4, 63) , 0 )
			b% = max(min(j% * colfact / 8, 63) , 0 )
		case 4
			r% = max(min(j% * colfact / 4, 63) , 0 )
			g% = max(min(j% * colfact / 2, 63) , 0 )
			b% = max(min(j% * colfact / 8, 63) , 0 )
		case 2
			r% = max(min(j% * colfact / 8, 63) , 0 )
			g% = max(min(j% * colfact / 2, 63) , 0 )
			b% = max(min(j% * colfact / 4, 63) , 0 )

		end select
	out &h3c8 , i%
	out &h3c9 , r%
	out &h3c9 , g%
	out &h3c9 , b%
	next i%
end sub

sub textXY256(text$ , x% , y% , colour% , fontno%)
	DEF SEG = &hA000
	shared ysize% , bitpatt$()
	select case fontno%
	case 1 , 5 , 7                '7x5 font
		rowsperchar% = 8
		colsperchar% = 6
		arrayref% = 0
	case 2 , 8
   	rowsperchar% = 8
		colsperchar% = 8
		arrayref% = 1
	case 3 , 14
		rowsperchar% = 14
		colsperchar% = 8
		arrayref% = 2
	case 4 , 16
		rowsperchar% = 16
		colsperchar% = 8
		arrayref% = 3
	end select

	for charcount% = 1 to len(text$)
		ch% = asc(mid$(text$ , charcount% , 1))
		xbase% = x% + colsperchar% * (charcount% - 1)
		for rw% = 0 to rowsperchar% - 1
			thisch% = asc(mid$(bitpatt$(arrayref%) , 1 + rw% + ch% * rowsperchar% , 1))
			for bitno% = 0 to 7
				if bit(thisch% , 7 - bitno%) then
					adr& = xbase% + bitno% + 320 * (y% + rw% - rowsperchar%)
					poke adr& , colour%
				end if
			next bitno%
		next rw%
	next charcount%
end sub

sub ReadFonts
	shared bitpatt$()
	fino% = freefile
	open "b" , fino% , "allfonts"
	get$  fino% , 2048 , bitpatt$(0)
	get$  fino% , 2048 , bitpatt$(1)
	get$  fino% , 3584 , bitpatt$(2)
	get$  fino% , 4096 , bitpatt$(3)
	close fino%
end sub

sub Clrscn
	shared logflag%
	for a& = 0 to 64000
		poke a& , 0
	next a&
   for y% = 0 to 127
		col% = 255 - y% * 2
		for x% = 315 to 319
			adr& = x% + 320 * y% + 640
			poke adr& , col%
		next x%
		if (col% mod 50 = 1) then
			if logflag% then _
				call textxy256(using$("## dB" , col% / 5) , 280 , y% + 6 , 128 , 1)_
			else _
				call textxy256(using$("####" , (col% - 1) * 4) , 280 , y% + 6 , 128 , 1)
		end if
	next y%
end sub

sub MakeBMP
	basename$ = "WF256"
	filename$ = dir$(basename$ + "???.bmp")
	n% = val(mid$(filename$ , 6, 3))
	do
		f$ = dir$
		n% = max(val(mid$(f$ , 6, 3)) , n%)
	loop until f$ = ""
	n$ = mid$(str$(min(n% + 1, 999)) , 2)
	do while len(n$) < 3
		n$ = "0" + n$
	loop
	f$ = basename$ + n$ + ".BMP"
	bwidth& = 320
	bheight& = 200
	ColoursInTable& = 256
	BitsPerPixel% = 8        '1 / 4 / 8 / 24  only
	NPlanes% = 1             '1 only
	InfoSize& = 40

	ImageSize& = bwidth& * bheight& * BitsperPixel% / 8
	dataoffset& = 62 + ColoursInTable& * 4
	filesize& = dataoffset& + ImageSize&

	fino% = freefile
	open "b" , fino% , f$

	bm$ = "BM"
	put$ fino% , bm$
	put fino% , 2 , filesize&
	put fino% ,, i1%
	put fino% ,, i2%
	put fino% ,, DataOffset&
	put fino% ,, InfoSize&
	put fino% ,, bwidth&
	put fino% ,, bheight&
	put fino% ,, NPlanes%
	put fino% ,, BitsPerPixel%
	put fino% ,, compression&
	put fino% ,, ImageSize&
	put fino% ,, XPelsPerMetre&
	put fino% ,, YPelsPerMetre&
	put fino% ,, ColoursInTable&
	put fino% ,, ImportantColours&
	seek fino% , 54
	for c% = 0 to coloursintable& - 1
		reg 1 , &h1015
		reg 2 , c%
		call interrupt &h10
		g% = reg(3) \ 256
		b% = reg(3) mod 256
		r% = reg(4) \ 256
		cd$ = chr$(4 * b%) + chr$(4 * g%) + chr$(4 * r%) + chr$(0)
		put$ fino% , cd$
	next c%
	seek fino% , dataoffset&      'data starts at bottom left of picture
	for y& = bheight& -1 to 0 step -1
		dat$ = peek$(y& * bwidth& , 320)
		put$ fino% , dat$
	next y&
	close fino%
	sound 1750 , 2
end sub

Sub ShowText
	shared basesamplerate , decim% , nsamples% , avno% , shft%
	shared binsize , viewspan , logflag% , powerflag%
   for xc% = 256 to 320
		for yc% = 145 to 199
			poke xc% + yc% * 320 , 0
		next yc%
	next xc%
	call textxy256(using$("Span ####" , shft% * binsize), 258 , 155 , 128 , 1)
	call textxy256("    -" + using$("####" , shft% * binsize + viewspan) , 258 , 165 , 128 , 1)
	call textxy256(using$("Bin ###.#" , binsize) , 258 , 175 , 128 , 1)
	call textxy256(using$("Avge ##", avno%) , 258 , 185 , 128 , 1)
	p$ = "Voltage"
	if powerflag% then p$ = "  Power"
	if logflag% then p$ = "    Log"
	call textxy256(p$ , 270 , 140 , 128 , 1)
end sub

DoAction:
	a$ = ucase$(inkey$)
	select case a$
	case "+"
		nsamples% = min (nsamples% * 2 , 8192)
		l% = 0
		clrscn
		counter& = 0
		shft% = shft% * 2
	case "-"
		nsamples% = max (nsamples% \ 2 , 32)
		l% = 0
		clrscn
		counter& = 0
		shft% = shft% / 2
	case "V"
		incr avno%
	case chr$(22)
		avno% = max(avno% - 1 , 1)
	case "C"
		colfact = colfact * 1.1
		call SetUpPalette
	case chr$(3)
		colfact = colfact / 1.1
		call SetUpPalette
	case "R"
		clrscn
		l% = 0
		counter& = 0
	case "D"
		incr decim% , 1
		clrscn
		l% = 0
		counter& = 0
	case chr$(4)
		decim% = max(decim% - 1 , 1)
		clrscn
		l% = 0
		counter& = 0
	case chr$(27)
		screen 0 , 0 , 0
		end
	case chr$(0 ,75)
		shft% = max(shft% - 128 , 0)
	case chr$(0 , 77)
		shft% = min(shft% + 128 , nsamples% / 2 - 256)
	case chr$(0 , 155)
		shft% = max(shft% - 512 , 0)
	case chr$(0 , 157)
		shft% = min(shft% + 512 , nsamples% / 2 - 256)
	case "T"
		threshold% = threshold% - 2
      call SetUpPalette
	case chr$(20)
		threshold% = threshold% + 2
		call SetUpPalette
	case "N"
		colfact = 2
		threshold% = 0
		call SetUpPalette
	case "P"
		palno% = (palno% + 1) mod 5
		call SetUpPalette
	case chr$(0 , 59)
		call MakeBMP
	end select
	if nsamples% <= 512 then shft% = 0
	samplerate = basesamplerate / decim%
	span = samplerate / 2
	binsize = samplerate / nsamples%
	viewspan = span
	if nsamples% > 512 then
		viewspan = 256 * binsize
	end if
	a$ = ""
	ShowText
	if fmark > 0 then markx% = (fmark / binsize) - shft%
	if markx% > 0 and markx% < 256 then
		poke oldmarkx% + 320 * 197 , 0
		poke oldmarkx% + 320 * 198 , 0
		poke oldmarkx% + 320 * 199 , 0
		poke markx% + 320 * 197 , 255
		poke markx% + 320 * 198 , 255
		poke markx% + 320 * 199 , 255
	end if
   oldmarkx% = markx%
return
