data 0,8, 1, 9,25 ,5,12, 4,36,52,38,26,22,62,55,63
defdbl a - z
pi = 3.141592653589793
colfact = .1
dim cols%(11)
dim huge dat(16384)
screen 12
color 15
locate 2 , 10
print "Display data stored in data file "
color 7
locate 12 , 1
files("*.dat")
fi$ = command$
locate 5 , 20 : color 11
if fi$ = "" then input "File name  ", fi$
if instr(fi$ , ".") = 0 then fi$= fi$ + ".dat"
fi$ = ucase$(fi$)
if dir$(fi$) = "" then
	sound 400 , 1
	print "No file"
	end
end if
cls
locate 5 , 20
color 12 : print "G";
color 15  : print "rey scale or ";
color 12 : print "C";
color 15  : print "olour"
while not instat : wend
if ucase$(inkey$) = "G" then grey% = -1

open "B" , 1 , fi$
n& = lof(1) - 1
locate 7 , 20
input "Sampling rate  ",fs
if fs = 0 then fs = 10000
if grey% then
	for i% = 0 to 15
		r% = i% * 4 + 3
		g% = i% * 4 + 3
		b% = i% * 4 + 3
		reg 1 , &h1010
		reg 2 , i%
		reg 3 , 256 * g% + b%
		reg 4 , r% * 256
		call interrupt &h10
		palette i% , i%
	next i%
else
	for t% = 0 to 15
		read pa%
		palette t% , pa%
	next t%
end if
lastwt% = 2          'default to Hamming window
lastwf% = -1         'default to waterfall display
oldfft% = 512
do
	cls
	locate 9 , 20
	input; "FFT Size             ",fftpoints%
	if fftpoints% = 0 then fftpoints% = oldfft% : print fftpoints% else print
	oldfft% = fftpoints%
	fftpoints% = 2 ^  int(log(fftpoints%) / log(2) + .5)  'only binary values allowed
	if fftpoints% < 256 then horshift% = fftpoints% * 1.25 else horshift% = 0
	locate 11 , 8
	print  "Window type ";
	color 10:print "N";:color 15:print "one    ";
	color 10:print "H";:color 15:print "amming   ";
	color 10:print "B";:color 15:print "lackman Harris";
	while not instat : wend
	windowtype% = instr("NHB" , ucase$(inkey$))
	if windowtype% = 0 then windowtype% = lastwt%
	lastwt% = windowtype%
	locate 13 , 8
	color 10:print "W";:color 15:print "aterfall display    or   3";
	color 10:print "D";:color 15:print "  time / frequency"
	while not instat : wend
	ik$ = ucase$(inkey$)
	if ik$ = "W" then wfall% = -1
	if ik$ = "3" or ik$ = "D" then wfall% = 0
	if ik$ = chr$(13) then wfall% = lastwf%
	lastwf% = wfall%
	interval% = max(1 , 1024 / fftpoints%)
	cls
   locate 30 , 1
	print using "File \          \ #### Points  Sampling rate ##### Hz ###.# Hz Bins"; fi$ , fftpoints% , fs , fs / fftpoints%;
	showmap
	ortho = 30
	sc = sin(ortho * pi / 180)
	cc = cos(ortho * pi / 180)
	seek 1 , 0
	for l% = 0 to n& \ fftpoints% - 1
		for r% =  1 to fftpoints% * 2 step 2
			get$ 1 , 1 , v$
			if v$ > "" then v% = asc(v$) - 128 else v% = 0
			dat(r%) = v%
			dat(r% + 1) = 0
		next r%

		select case windowtype%
		case 1
			weight = 1
		case 2
			call HammingWind(dat() , fftpoints%)
			weight = 1 / .54
		case 3
			call BlackHarrisWind(dat() , fftpoints%)
			weight = 1 / .42
		end select
		windowtype$ = mid$("No window  Hamming    Bla. Harris" , windowtype% * 11 - 10 , 11)

		call FFT (dat() , fftpoints%)
		maxmagsq = 0
		if fftpoints% < 256 then expand% = -1 else expand% = 0
		for k% = 2 to fftpoints% step 2     '1/2 of calculated points at re + im per measurement
			magsq =weight * ((dat(k% - 1) ^ 2 + dat(k%) ^ 2) / fftpoints% ^ 2)
			if not lin% then
				colref% = max((magsq - threshold) * colfact , 1)
			else
				if magsq > 0 then
					colref% = max(colfact * 10 * log10(magsq - threshold) , 1)
				else
					colref% = 0
				end if
			end if
			colref% = min(colref% , 15)
			if wfall% then
				x% = k% + horshift% * loopround%
				if not expand% then shift right x% , 1          'divide by 2
				y% = l% mod 460
				loopround% = l% \ 460
				pset (x% , y%) , colref%

				if expand% then
					incr x% , 1
					pset (x% , y%) , colref%
				end if
			else
				dispheight = min(magsq / 10 , 20)
				k1% = k% / 2
				x% =(k1% + l%) * cc
				y% = (200 - k1% + l%) * sc  - dispheight
				if k% = 2 then pset (x% , y%) , colref% else line - (x% , y%) , colref%
			end if
		next k%
		locate 30 , 70
		print windowtype$;
		ik$ = ucase$(inkey$)
		if ik$ = chr$(27) then exit for
		if ik$ = "C" then colfact = colfact * 1.1
		if ik$ = chr$(4) then colfact = colfact / 1.1
		if ik$ = "W" then incr windowtype%
		if windowtype% = 4 then windowtype% = 1
	next l%
	sound 400 , 2
	while not instat
		if inkey$ = chr$(0 ,59) then call DumpVGAtoBMP("WFLFI") : ik$ = ""
	wend
	locate 30 , 1
	print space$(79);
	locate 30 , 1
	print "Repeat FFT   Y / n";
	while not instat : wend
	ik$ = ucase$(inkey$)
loop until ik$ ="N"
locate 30 , 1
end


sub FFT(dat(1) , nn%)
'data format  (re,im,re,im,....) starting at 1
	shared pi
	n% = 2 * nn%
	j% = 1
	for i% = 1 to n% step 2
		if j% > i% then
			swap dat(i%) , dat(j%)
			swap dat(i% + 1) , dat(j% + 1)
		end if
		m% = n% \ 2
		while m% >= 2 and j% > m%
			decr j% , m%
			m% = m% \ 2
		wend
		incr j% , m%
	next i%
	mmax% = 2

	while n% > mmax%
		istep% = 2 * mmax%
		theta = 2 * pi / mmax%
		wpr = cos(theta)
		wpi = sin(theta)
		wr = 1
		wi = 0
		for m% = 1 to mmax% step 2
			for i% = m% to n% step istep%
				j% = i% + mmax%
				tempr = wr * dat(j%) - wi * dat(j% + 1)
				tempi = wr * dat(j% + 1) + wi * dat(j%)
				dat(j%) = dat(i%) - tempr
				dat(j% + 1) = dat(i% + 1) - tempi
				dat(i%) = dat(i%) + tempr
				dat(i% + 1) = dat(i% + 1) + tempi
			next i%
			wtemp = wr
			wr = wr * wpr - wi * wpi
			wi = wi * wpr + wtemp * wpi
		next m%
		mmax% = istep%
	wend
end sub

sub BlackHarrisWind (dat() , n%)
	shared pi
	for k% = 0 to n% - 1
   	locdat% = k% * 2 + 1
		theta = 2 * pi * k% / n%
		dat(locdat%) = dat(locdat%) * (.42323 - .49755 * cos(theta) + .07922 * cos(2 * theta))
	next k%
end sub

sub HammingWind (dat() , n%)
	shared pi
	for k% = 0 to n% - 1
		locdat% = k% * 2 + 1
		theta = 2 * pi * k%/ n%
		dat(locdat%) = dat(locdat%) * (.54 - .46 * cos(theta))
	next k%
end sub

sub ShowMap
	shared cols%()
	for t% = 0 to 15
		color t%
		locate t% + 7 , 80
		print "";
	next t%
end sub

sub DumpVGAToBmp (basename$)            '16 colour VGA
	filename$ = dir$(basename$ + "???.bmp")
	n% = val(mid$(filename$ , 6, 3))
	do
		f$ = dir$
		n% = max(val(mid$(f$ , 6, 3)) , n%)
	loop until f$ = ""
	n$ = mid$(str$(min(n% + 1, 999)) , 2)
	do while len(n$) < 3
		n$ = "0" + n$
	loop
	f$ = basename$ + n$ + ".BMP"
	bwidth& = 640           'previously set by   PALETTE CO%,CO%
	bheight& = 480
	ColoursInTable& = 16
	BitsPerPixel% = 4        '1 / 4 / 8 / 24  only
	NPlanes% = 1             '1 only
	InfoSize& = 40

	ImageSize& = bwidth& * bheight& * BitsperPixel% / 8
	dataoffset& = 54 + ColoursInTable& * 4
	filesize& = dataoffset& + ImageSize&

	t = timer
	if instr(ucase$(f$) , ".BMP") = 0 then f$ = f$ + ".BMP"
	fi% = freefile
	open "b" , fi% , f$
	i1% = 0 : i2% = 0 : compression& = 0
	bm$ = "BM"
	put$ fi% , bm$
	put fi% , 2 , filesize&
	put fi% ,, i1%
	put fi% ,, i2%
	put fi% ,, DataOffset&
	put fi% ,, InfoSize&
	put fi% ,, bwidth&
	put fi% ,, bheight&
	put fi% ,, NPlanes%
	put fi% ,, BitsPerPixel%
	put fi% ,, compression&
	put fi% ,, ImageSize&
	put fi% ,, XPelsPerMetre&
	put fi% ,, YPelsPerMetre&
	put fi% ,, ColoursInTable&
	put fi% ,, ImportantColours&

	seek fi% , 54
	for rgb% = 0 to 15  'palette tables assumes  PALETTE CO , CO for each colour.
		reg 1 , &h1015
		reg 2 , rgb%
		call interrupt &h10
		b% = (reg(3) mod 256) * 4
		g% = (reg(3) \ 256) * 4
		r% = (reg(4) \ 256) * 4
		pa$ = chr$(b%) + chr$(g%) + chr$(r%) + chr$(0)
		put$ fi% , pa$
	next rgb%

	seek fi% , dataoffset&         'data starts at bottom left of picture
	nibble% = 0
	for y% = bheight& - 1 to 0 step -1
		dat$ = ""
		for x% = 0 to bwidth& - 2 step 2
				d% = 16 * point (x% , y%) + point (x% + 1 , y%)
				dat$ = dat$ + chr$(d%)
		next x%
      put$ fi% , dat$
	next y%
	close fi%
	sound 1750 , 2
end sub

